##########################################################################################
# HAM Makefile
#
# Created by VisualHAM - www.console-dev.de
#
##########################################################################################
HAMDIR = C:\HAM
GCCARM = C:\HAM\gcc-arm

include ${HAMDIR}/system/master.mak

#
# See HEL2 API documentation for details on this
#
ADD_LIBS += $(GCCARM)/lib/libhel2.a
#CFLAGS += -DHEL_DEBUG

#
# Set the name of your desired GBA image name here
#
PROGNAME=Last_Quest

#
# Compile using Krawall software (set to yes or no) ?
# Also specify if Krawall is registered (yes or no)  
#
USE_KRAWALL=no
KRAWALL_IS_REGISTERED=no
KRAWALL_FILES= 

#
# Set a list of files you want to compile
#
OFILES += main.o	\
	animations.o  \
	bonus.o  \
	collisions.o  \
	divers.o  \
	ennemis.o  \
	fin.o  \
	foes_terre.o  \
	foes_mer.o  \
	foes_ciel.o  \
	init.o	\
	level1-1.o	\
	level1-2.o	\
	level1-3.o	\
	level1-4.o	\
	level1-5.o	\
	level1-6.o	\
	level1-7.o	\
	level1-8.o	\
	mario.o  \
	plateformes.o  \
	secret.o  \
	texte.o  \
	touches.o  \
	Adpcm.o  \
	sfx/musiques/monde1_intro.o  \
	sfx/musiques/monde2_intro.o  \
	sfx/musiques/monde3_intro.o  \
	sfx/musiques/monde4_intro.o  \
	sfx/musiques/monde5_intro.o  \
	sfx/musiques/monde6_intro.o  \
	sfx/musiques/monde7_intro.o  \
	sfx/musiques/monde8_intro.o  \
	sfx/musiques/monde1.o  \
	sfx/musiques/monde2.o  \
	sfx/musiques/monde3.o  \
	sfx/musiques/monde4.o  \
	sfx/musiques/monde5.o  \
	sfx/musiques/monde6.o  \
	sfx/musiques/monde7.o  \
	sfx/musiques/monde8.o  \
	sfx/musiques/bonusm.o  \
	sfx/musiques/boss.o  \
	sfx/musiques/bossintro.o  \
	sfx/musiques/carte.o  \
	sfx/musiques/finm.o  \
	sfx/musiques/intro.o  \
	sfx/musiques/gameover.o  \
	sfx/musiques/bosshs.o  \
	sfx/sons/bonuss.o  \
	sfx/sons/boum.o  \
	sfx/sons/bump.o  \
	sfx/sons/ennemi.o  \
	sfx/sons/frein.o  \
	sfx/sons/grandir.o  \
	sfx/sons/rapetir.o  \
	sfx/sons/piece.o  \
	sfx/sons/saut.o  \
	sfx/sons/tir.o  \
	sfx/sons/vie.o  \
	sfx/sons/mort.o  \
	sfx/sons/mort2.o  \
	sfx/sons/invincible.o  \
	sfx/sons/expl_bloc.o  \
	sfx/sons/bipmap.o  \
	sfx/sons/bipmenu.o  \
	sfx/sons/startmap.o  \
	sfx/sons/startmenu.o  \
	sfx/sons/pause.o  \
	sfx/sons/tuyau.o  \
	sfx/sons/finniveau.o  \
	sfx/sons/boulet.o  \
	sfx/sons/sphinxtir.o  \
	sfx/sons/hippo.o  \
		

ADD_LIBS += 


##########################################################################################
# Standard Makefile targets start here
##########################################################################################
all : $(PROGNAME).$(EXT)

#
# Most Makefile targets are predefined for you, suchas
# vba, clean ... in the following file
#
include $(HAMDIR)/system/standard-targets.mak

##########################################################################################
# Custom  Makefile targets start here
##########################################################################################

gfx: makefile
#	gfx2gba
